`timescale 1ns / 1ps
`include "../proj/src/define/define.vh"

module tb();
//**********************************************************************
// --- Parameter
//**********************************************************************
localparam WIDTH_P = 128;
//**********************************************************************
// --- Test Input/Output signal
//**********************************************************************	
reg	clk;
reg rstn;

wire        [WIDTH_P-1:0]  		  product;

localparam CLK_PERIOD = 50.0;
//**********************************************************************
// --- Reset 
//**********************************************************************
initial begin
	rstn = 1'b1;
	#(1.5*CLK_PERIOD) rstn = 1'b0;
	#(CLK_PERIOD) rstn = 1'b1;
end
//**********************************************************************	
// --- Clock Generate
//**********************************************************************
initial begin
	clk = 1'b1;
	#(1.5*CLK_PERIOD) 
	forever #(CLK_PERIOD/2.0) clk = ~clk;
end
//**********************************************************************	
// --- Initial Block
//**********************************************************************
tb_gw2a tb_gw2a_tb(
    .clk    	  (   clk            ),
    .rstn   	  (   rstn    	     ),
	
    .product	  (   product        )
);

endmodule