`include "define.vh"
module tb_gw2a(
    clk,
    rstn,

    product
	 );
//**********************************************************************
// --- Parameter
//**********************************************************************
    localparam WIDTH_A = 64;
    localparam WIDTH_B = 64;
    localparam WIDTH_P = WIDTH_A+WIDTH_B;
    localparam NUM_DATA = 100;
//**********************************************************************
// --- Test Input signal
//**********************************************************************
	input clk;
	input rstn;
//**********************************************************************
// --- Test Output signal
//**********************************************************************
    reg [WIDTH_A-1:0] a;
    reg [WIDTH_B-1:0] b;
	output         [WIDTH_P-1:0]  		  product;
//**********************************************************************
// --- Define Variable
//**********************************************************************
	reg [6:0]      						i_data;
    wire [6:0]                          done = NUM_DATA-1;
    reg [WIDTH_A-1:0] mem_data_1 [0:NUM_DATA-1];
    reg [WIDTH_B-1:0] mem_data_2 [0:NUM_DATA-1];
//**********************************************************************
// --- Initial Block
//**********************************************************************
Integer_Multiplier_Top Integer_Multiplier_Top_tb
(  
`ifdef PIPELINE
  .clk          ( clk          ),
  .rstn         ( rstn         ),
`endif
   .mul_a 		( a            ),
   .mul_b  		( b            ),
   .product     ( product      )
);
//**********************************************************************
// --- Input simulation
//**********************************************************************
initial begin
       $readmemh("data/multiplicand.dat",mem_data_1);
       $readmemh("data/multiplier.dat",mem_data_2);
end

always @(posedge clk or negedge rstn) begin
    if(!rstn) begin
        i_data <= 0;
    end
    else if(i_data < done) begin
        i_data <= i_data + 1'b1;
    end
end

always @(posedge clk or negedge rstn) begin
    if(!rstn) begin
        a <= 0;
        b <= 0;
    end
    else begin
        a <= mem_data_1[i_data];
        b <= mem_data_2[i_data];
    end
end
endmodule